alala Posté(e) le 4 janvier 2013 Partager Posté(e) le 4 janvier 2013 Bonjour, Cherchant à vérifier que mes blocs sont identiques par rapport à une légende ou un gabarit, je souhaitait lister toutes les propriètes de ceux-ci en Vlisp. Actuellement j'ai fait une bête liste de toutes les propriètes par type d'objets tel que l'on la trouve dans l'aide VBA, mais je m'étonne de ne pas avoir trouvé de méthode pour refaire une liste de celle-ci automatiquement (type celle que l'on trouveen effectuant un vlax-dump-object (que je n'arrive pas à exploiter dans mes lisp)). Sachant que je ne souhaite pas lister certaines propriétés (typiquemens celle qui vont différés d'un plans à l'autre sans l'object ne soit modifiés). Avez vous une méthode pour réaliser cela? C'est en forgeant que l'on devient forgerons.Et c'est en sciant que Léonard DeVinci! Lien vers le commentaire Partager sur d’autres sites More sharing options...
VDH-Bruno Posté(e) le 5 janvier 2013 Partager Posté(e) le 5 janvier 2013 Bonsoir, mais je m'étonne de ne pas avoir trouvé de méthode pour refaire une liste de celle-ci automatiquement (type celle que l'on trouveen effectuant un vlax-dump-object (que je n'arrive pas à exploiter dans mes lisp)). Je ne connais pas de méthode en natif pour réaliser cela, ci-dessous un code écrit pour l’occasion (également avec une bête liste des propriétées établit d'après l’aide VBA pour 2013 ;) ). ;; (list-property-availabe obj flag) VDH-Bruno ;; ------------------------------------------------------------------------ ;; Retourne la liste des propriétées de l'objet argument. Si flag et ;; différent de nil, les propriétées en lecture seules sont omises. ;; Exemple: ;; (list-property-availabe (vlax-ename->vla-object (car (entsel))) nil) ;; (list-property-availabe (vlax-ename->vla-object (car (entsel))) T) ;; Nota: Liste des propriétées établie d'après les fichiers d'aide de la ;; version 2013. (defun list-property-availabe (obj flag) (vl-remove-if-not '(lambda (prop) (vlax-property-available-p obj prop flag)) '(Action Active ActiveDimStyle ActiveDocument ActiveInvProject ActiveLayer ActiveLayout ActiveLinetype ActiveMaterial ActiveProfile ActivePViewport ActiveSelectionSet ActiveSpace ActiveTextStyle ActiveUCS ActiveViewport ADCInsertUnitsDefaultSource ADCInsertUnitsDefaultTarget AdjustForBackground AdjustForBackground AffectsGraphics Algorithm Alignment AlignmentPointAcquisition AlignSpace AllowedValues AllowLongSymbolNames AllowManualHeights AllowManualPositions AltFontFile AltRoundDistance AltSubUnitsFactor AltSubUnitsSuffix AltSuppressLeadingZeros AltSuppressTrailingZeros AltSuppressZeroFeet AltSuppressZeroInches AltTabletMenuFile AltTextPrefix AltTextSuffix AltTolerancePrecision AltToleranceSuppressLeadingZeros AltToleranceSuppressTrailingZeros AltToleranceSuppressZeroFeet AltToleranceSuppressZeroInches AltUnits AltUnitsFormat AltUnitsPrecision AltUnitsScale Angle AngleFormat AngleVertex Annotation Annotative Application ArcEndParam ArcLength ArcPoint ArcSmoothness ArcStartParam Area Arrowhead1Block Arrowhead1Type Arrowhead2Block Arrowhead2Type ArrowheadBlock ArrowheadSize ArrowheadType ArrowSize ArrowSymbol AssociativeHatch AttachmentPoint Author AutoAudit AutomaticPlotLog AutoSaveInterval AutoSavePath AutoSnapAperture AutoSnapApertureSize AutoSnapMagnet AutoSnapMarker AutoSnapMarkerColor AutoSnapMarkerSize AutoSnapToolTip AutoTrackingVecColor AutoTrackTooltip AxisDirection AxisPosition BackgroundColor BackgroundFill BackgroundLinesColor BackgroundLinesHiddenLine BackgroundLinesLayer BackgroundLinesLinetype BackgroundLinesLinetypeScale BackgroundLinesLineweight BackgroundLinesPlotStyleName BackgroundLinesVisible Backward Bank BasePoint BaseRadius BatchPlotProgress BeepOnError BigFontFile BitFlags BitFlags Block Block BlockColor BlockConnectionType BlockRotation Blocks BlockScale BlockScaling Blue BookName BottomHeight BreaksEnabled BreakSize BreakSpacing Brightness CanonicalMediaName Caption CategoryName Center CenterMarkSize CenterPlot CenterPoint CenterType Centroid Check ChordPoint Circumference Clipped ClippingEnabled Closed Closed2 Color ColorBookPath ColorIndex ColorMethod ColorName Columns Columns ColumnSpacing ColumnWidth CommandDisplayName Comment Comments Comments ConfigFile ConfigName Constant ConstantWidth Constrain ContentBlockName ContentBlockType ContentType ContinuousPlotLog ContourlinesPerSurface Contrast ControlPoints Coordinate Coordinates Count CreaseLevel CreaseType CreateBackup CurrentSectionType CursorSize CurveTangencyLinesColor CurveTangencyLinesLayer CurveTangencyLinesLinetype CurveTangencyLinesLinetypeScale CurveTangencyLinesLineweight CurveTangencyLinesPlotStyleName CurveTangencyLinesVisible CustomDictionary CustomIconPath CustomScale CvHullDisplay Database DecimalSeparator DefaultInternetURL DefaultOutputDevice DefaultPlotStyleForLayer DefaultPlotStyleForObjects DefaultPlotStyleTable DefaultPlotToFilePath DefaultPlotToFilePath Degree Degree2 Delta DemandLoadArxApp Description DestinationBlock DestinationFile Diameter Dictionaries DimConstrDesc DimConstrExpression DimConstrForm DimConstrName DimConstrReference DimConstrValue DimensionLineColor DimensionLineExtend DimensionLinetype DimensionLineWeight DimLine1Suppress DimLine2Suppress DimLineInside DimLineSuppress DimStyles DimTxtDirection Direction DirectionVector Display DisplayGrips DisplayGripsWithinBlocks DisplayLayoutTabs DisplayLocked DisplayOLEScale DisplayScreenMenu DisplayScrollBars DisplaySilhouette DockedVisibleLines DockStatus Document Documents DogLegged DoglegLength Drafting DrawingDirection DrawLeaderOrderType DrawMLeaderOrderType DriversPath DWFFormat EdgeExtensionDistances EffectiveName Elevation ElevationModelSpace ElevationPaperSpace Enable EnableBlockRotation EnableBlockScale EnableBreak EnableDogleg EnableFrameText EnableLanding EnableShadowDisplay EnableStartupDialog EndAngle EndDraftAngle EndDraftMagnitude EndParameter EndPoint EndSmoothContinuity EndSmoothMagnitude EndSubMenuLevel EndTangent EnterpriseMenuFile EntityColor EntityTransparency Explodable ExtensionLineColor ExtensionLineExtend ExtensionLineOffset ExtensionLineWeight ExtLine1EndPoint ExtLine1Linetype ExtLine1Point ExtLine1StartPoint ExtLine1Suppress ExtLine2EndPoint ExtLine2Linetype ExtLine2Point ExtLine2StartPoint ExtLine2Suppress ExtLineFixedLen ExtLineFixedLenSuppress FaceCount Fade Feature FieldLength File FileName Files FileSize FingerprintGUID FirstSegmentAngleConstraint Fit FitPoints FitTolerance FloatingRows FlowDirection Flyout FontFile FontFileMap ForceLineInside ForegroundLinesColor ForegroundLinesEdgeTransparency ForegroundLinesFaceTransparency ForegroundLinesHiddenLine ForegroundLinesLayer ForegroundLinesLinetype ForegroundLinesLinetypeScale ForegroundLinesLineweight ForegroundLinesPlotStyleName ForegroundLinesVisible FoundPath FractionFormat Freeze FullCRCValidation FullFileName FullName FullScreenTrackingVector GenerationOptions GradientAngle GradientCentered GradientColor1 GradientColor2 GradientName GraphicsWinLayoutBackgrndColor GraphicsWinModelBackgrndColor Green GridOn GripColorSelected GripColorUnselected GripSize Groups Handle HasAttributes HasExtensionDictionary HasLeader HasSheetView HasSubSelection HasVpAssociation HatchObjectType HatchStyle HeaderSuppressed Height HelpFilePath HelpString History HistoryLines HorizontalTextPosition HorzCellMargin HWND HWND32 HyperlinkBase HyperlinkDisplayCursor HyperlinkDisplayTooltip Hyperlinks ImageFile ImageFrameHighlight ImageHeight ImageVisibility ImageWidth IncrementalSavePercent Index IndicatorFillColor IndicatorTransparency InsertionPoint InsertionPoint InsUnits InsUnitsFactor IntensityColorScheme IntersectionBoundaryColor IntersectionBoundaryDivisionLines IntersectionBoundaryLayer IntersectionBoundaryLinetype IntersectionBoundaryLinetypeScale IntersectionBoundaryLineweight IntersectionBoundaryPlotStyleName IntersectionBoundaryVisible IntersectionFillColor IntersectionFillFaceTransparency IntersectionFillHatchAngle IntersectionFillHatchPatternName IntersectionFillHatchPatternType IntersectionFillHatchScale IntersectionFillHatchSpacing IntersectionFillLayer IntersectionFillLinetype IntersectionFillLinetypeScale IntersectionFillLineweight IntersectionFillPlotStyleName IntersectionFillVisible Invisible IsCloned IsDynamicBlock IsLayout IsModified ISOPenWidth IsOwnerXlated IsPartial IsPeriodic IsPlanar IsPrimary IsQuiescent IsRational Issuer IsXRef ItemName JogAngle JogLocation Justification Key Key32 KeyboardAccelerator KeyboardPriority KeyLength Keywords KnotParameterization Knots Label LabelBlockId LabelBlockId32 LandingGap LargeButtons LastHeight LastSavedBy Layer LayerOn LayerPropertyOverrides Layers LayerState Layout LayoutCreateViewport LayoutCrosshairColor LayoutDisplayMargins LayoutDisplayPaper LayoutDisplayPaperShadow LayoutID LayoutID32 Layouts LayoutShowPlotSetup Leader1Point Leader2Point LeaderCount LeaderLength LeaderLineColor LeaderLinetype LeaderLineTypeId LeaderLineWeight LeaderType Left Length LensLength Limits LinearScaleFactor LineSpacingDistance LineSpacingFactor LineSpacingStyle Linetype LinetypeGeneration Linetypes LinetypeScale Lineweight LineweightDisplay LiveSectionEnabled LoadAcadLspInAllDocuments LocaleID Lock LockAspectRatio Locked LockPosition LogFileOn LogFilePath LowerLeftCorner Macro MainDictionary MaintainAssociativity MajorAxis MajorRadius Mask Material Materials MaxActiveViewports MaxAutoCADWindow MaxLeaderSegmentsPoints Mclose Mdensity Measurement MenuBar MenuFile MenuFileName MenuGroups Menus MinimumTableHeight MinimumTableWidth MinorAxis MinorRadius MLineScale Mode ModelCrosshairColor ModelSpace ModelType ModelView MomentOfInertia Monochrome MRUNumber MSpace MTextAttribute MTextAttributeContent MTextBoundaryWidth MTextDrawingDirection MVertexCount Name NameNoMnemonic Nclose NDensity Normal NumberOfControlPoints NumberOfCopies NumberOfFaces NumberOfFitPoints NumberOfLoops NumberOfVertices NumCellStyles NumCrossSections NumGuidePaths NumVertices NVertexCount ObjectID ObjectID32 ObjectName ObjectSnapMode ObjectSortByPlotting ObjectSortByPSOutput ObjectSortByRedraws ObjectSortByRegens ObjectSortBySelection ObjectSortBySnap ObliqueAngle OleItemType OLELaunch OlePlotQuality OLEQuality OleSourceApp OnMenuBar OpenSave Origin OrthoOn Output OverrideCenter OwnerID OwnerID32 PageSetupOverridesTemplateFile PaperSpace PaperUnits Parent Password Path PatternAngle PatternDouble PatternName PatternScale PatternType Perimeter Periodic PickAdd PickAuto PickBoxSize PickDrag PickFirst PickfirstSelectionSet PickGroup Plot PlotConfigurations PlotHidden PlotLegacy PlotLogFilePath PlotOrigin PlotPolicy PlotRotation PlotStyleName Plottable PlotType PlotViewportBorders PlotViewportsFirst PlotWithLineweights PlotWithPlotStyles PolarTrackingVector Position PostScriptPrologFile Preferences Preset PrimaryUnitsPrecision PrincipalDirections PrincipalMoments PrinterConfigPath PrinterDescPath PrinterPaperSizeAlert PrinterSpoolAlert PrinterStyleSheetPath PrintFile PrintSpoolerPath PrintSpoolExecutable ProductOfInertia ProfileRotation Profiles PromptString PropertyName ProviderName ProviderType ProxyImage QNewTemplateFile QuietErrorMode RadiiOfGyration Radius RadiusRatio ReadOnly Red ReferenceCount RegenerateTableSuppressed RegisteredApplications RemoveHiddenLines RenderSmoothness RepeatBottomLabels RepeatTopLabels RevisionNumber RevolutionAngle Rotation RoundDistance RowHeight Rows RowSpacing SaveAsType Saved SavePreviewThumbnail Scale ScaleFactor ScaleHeight ScaleLineweights ScaleWidth SCMCommandMode SCMDefaultMode SCMEditMode SCMTimeMode SCMTimeValue SecondPoint SecondSegmentAngleConstraint SectionManager SegmentPerPolyline Selection SelectionSets SerialNumber Settings ShadePlot ShadowDisplay SheetView ShortCutMenu ShortCutMenuDisplay Show ShowAssociativity ShowClipped ShowHistory ShowIntensity ShowPlotStyles ShowProxyDialogBox ShowRasterImage ShowRotation ShowWarningMessages SingleDocumentMode Smoothness SnapBasePoint SnapOn SnapRotationAngle SolidFill SolidType SourceObjects SplineFrame SplineMethod StandardScale StandardScale2 StartAngle StartDraftAngle StartDraftMagnitude StartParameter StartPoint StartSmoothContinuity StartSmoothMagnitude State StatusID StoreSQLIndex StyleName StyleSheet Subject SubMenu SubUnitsFactor SubUnitsSuffix SummaryInfo SupportPath SuppressLeadingZeros SuppressTrailingZeros SuppressZeroFeet SuppressZeroInches SurfaceNormals SurfaceType SurfTrimAssociativity SymbolPosition System TableBreakFlowDirection TableBreakHeight TablesReadOnly TableStyleOverrides TabOrder TagString TaperAngle Target TempFileExtension TempFilePath TemplateDwgPath TemplateId TemplateId32 TempXRefPath TextAlignmentPoint TextAlignmentType TextAngleType TextAttachmentDirection TextAttachmentType TextBackgroundFill TextBottomAttachmentType TextColor TextDirection TextEditor TextFill TextFillColor TextFont TextFontSize TextFontStyle TextFrameDisplay TextGap TextGenerationFlag TextHeight TextInside TextInsideAlign TextJustify TextLeftAttachmentType TextLineSpacingDistance TextLineSpacingFactor TextLineSpacingStyle TextMovement TextOutsideAlign TextOverride TextPosition TextPrecision TextPrefix TextRightAttachmentType TextRotation TextString TextStyle TextStyleName TextStyles TextSuffix TextureMapPath TextWidth TextWinBackgrndColor TextWinTextColor Thickness TimeServer TimeStamp Title TitleSuppressed ToleranceDisplay ToleranceHeightScale ToleranceJustification ToleranceLowerLimit TolerancePrecision ToleranceSuppressLeadingZeros ToleranceSuppressTrailingZeros ToleranceSuppressZeroFeet ToleranceSuppressZeroInches ToleranceUpperLimit Toolbars ToolPalettePath Top TopHeight TopRadius TotalAngle TotalLength TranslateIDs Transparency TrueColor TrueColorImages TurnHeight Turns TurnSlope Twist TwistAngle Type UCSIconAtOrigin UCSIconOn UCSPerViewport UIsolineDensity UnderlayLayerOverrideApplied UnderlayName UnderlayVisibility Units UnitsFormat UnitsType UpperRightCorner UpsideDown URL URLDescription URLNamedLocation Used UseEntityColor UseLastPlotSettings User UseStandardScale Utility Value Value32 VBE Verify Version VersionGUID VertCellMargin VertexCount VerticalDirection VerticalTextPosition Vertices ViewingDirection ViewportDefault ViewportOn Viewports Views ViewToPlot VisibilityEdge1 VisibilityEdge2 VisibilityEdge3 VisibilityEdge4 Visible VIsolineDensity VisualStyle Volume Weights Width WindowLeft WindowState WindowTitle WindowTop WireframeType WorkspacePath XEffectiveScaleFactor XRefDatabase XrefDemandLoad XRefEdit XRefFadeIntensity XRefLayerVisibility XScaleFactor XVector YEffectiveScaleFactor YScaleFactor YVector ZEffectiveScaleFactor ZScaleFactor ) ) ) A+ Apprendre => Prendre => Rendre Lien vers le commentaire Partager sur d’autres sites More sharing options...
alala Posté(e) le 14 janvier 2013 Auteur Partager Posté(e) le 14 janvier 2013 Après une petite semaine de vacance je reviens sur ce sujet. Tout d'abord merci pour cette réponse.Je trouve cela bien dommage qu'il n'y ait pas de solution pour retrouver ces propriétés par objet sans les lister au préalable. J'ai utilisé la même source pour réaliser la fonction suivante (épuré de quelques propriétés donc!) : ;;;---------------------------------------------------------------------------; ;;; Listes de propriétés par type d'objets ; ;;;---------------------------------------------------------------------------; (defun ListePropAcDbObject (ListPropAcDb /) (append (list 'ObjectName 'Material 'EntityTransparency 'HasExtensionDictionary 'Visible 'Layer 'Linetype 'LinetypeScale 'Lineweight 'PlotStyleName 'Normal ) (cond ( (equal ListPropAcDb "AcDb3DFace") (list 'Coordinates 'VisibilityEdge1 'VisibilityEdge2 'VisibilityEdge3 'VisibilityEdge4 ) ) ((equal ListPropAcDb "AcDb3DPolyline") (list 'Closed 'Coordinates 'Length 'Type ) ) ((equal ListPropAcDb "AcDb3DSolid") (list 'Centroid 'History 'MomentOfInertia 'Position 'PrincipalDirections 'PrincipalMoments 'ProductOfInertia 'RadiiOfGyration 'ShowHistory 'SolidType 'Volume ) ) ((equal ListPropAcDb "AcDbArc") (list 'ArcLength 'Area 'Center 'EndAngle 'EndPoint 'Radius 'StartAngle 'StartPoint 'Thickness 'TotalAngle ) ) ((equal ListPropAcDb "AcDbAttribute") (list 'Alignment 'Backward 'Constant 'FieldLength 'Height 'InsertionPoint 'Invisible 'LockPosition 'Mode 'MTextAttribute 'MTextAttributeContent 'MTextBoundaryWidth 'MTextDrawingDirection 'ObliqueAngle 'Preset 'PromptString 'Rotation 'ScaleFactor 'StyleName 'TagString 'TextAlignmentPoint 'TextGenerationFlag 'TextString 'Thickness 'UpsideDown 'Verify ) ) ((equal ListPropAcDb "AcDbAttributeReference") (list 'Alignment 'Backward 'Constant 'FieldLength 'Height 'InsertionPoint 'Invisible 'LockPosition 'MTextAttribute 'MTextAttributeContent 'MTextBoundaryWidth 'MTextDrawingDirection 'ObliqueAngle 'Rotation 'ScaleFactor 'StyleName 'TagString 'TextAlignmentPoint 'TextGenerationFlag 'TextString 'Thickness 'UpsideDown ) ) ((equal ListPropAcDb "AcDbBlockReference") (list 'EffectiveName 'HasAttributes 'InsertionPoint 'InsUnits 'InsUnitsFactor 'IsDynamicBlock 'Name 'Rotation 'XEffectiveScaleFactor 'XScaleFactor 'YEffectiveScaleFactor 'YScaleFactor 'ZEffectiveScaleFactor 'ZScaleFactor ) ) ((equal ListPropAcDb "AcDbCircle") (list 'Area 'Center 'Circumference 'Diameter 'Radius 'Thickness ) ) ((equal ListPropAcDb "AcDbDim3PointAngular") (list 'AngleFormat 'AngleVertex 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimLineInside 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineExtend 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLine1EndPoint 'ExtLine1Linetype 'ExtLine1Suppress 'ExtLine2EndPoint 'ExtLine2Linetype 'ExtLine2Suppress 'ExtLineFixedLen 'ExtLineFixedLenSuppress 'Fit 'ForceLineInside 'HorizontalTextPosition 'Measurement 'Rotation 'ScaleFactor 'StyleName 'SuppressLeadingZeros 'SuppressTrailingZeros 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrecision 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceUpperLimit 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimAligned") (list 'AltRoundDistance 'AltSubUnitsFactor 'AltSubUnitsSuffix 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLineExtend 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimLineInside 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineExtend 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLine1Linetype 'ExtLine1Point 'ExtLine1Suppress 'ExtLine2Linetype 'ExtLine2Point 'ExtLine2Suppress 'ExtLineFixedLen 'ExtLineFixedLenSupress 'Fit 'ForceLineInside 'FractionFormat 'HorizontalTextPosition 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SubUnitsFactor 'SubUnitsSuffix 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimAngular") (list 'AngleFormat 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimLineInside 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineExtend 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLine1EndPoint 'ExtLine1Linetype 'ExtLine1StartPoint 'ExtLine1Suppress 'ExtLine2EndPoint 'ExtLine2Linetype 'ExtLine2StartPoint 'ExtLine2Suppress 'ExtLineFixedLen 'ExtLineFixedLenSuppress 'Fit 'ForceLineInside 'HorizontalTextPosition 'Measurement 'Rotation 'ScaleFactor 'StyleName 'SuppressLeadingZeros 'SuppressTrailingZeros 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrecision 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceUpperLimit 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimArcLength") (list 'AltRoundDistance 'AltSubUnitsFactor 'AltSubUnitsSuffix 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'ArcEndParam 'ArcPoint 'ArcStartParam 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'CenterPoint 'DecimalSeparator 'DimensionLineColor 'DimensionLineExtend 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimLineInside 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineExtend 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLine1Linetype 'ExtLine1Point 'ExtLine1Suppress 'ExtLine2Linetype 'ExtLine2Point 'ExtLine2Suppress 'ExtLineFixedLen 'ExtLineFixedLenSuppress 'Fit 'ForceLineInside 'FractionFormat 'HasLeader 'HorizontalTextPosition 'IsPartial 'Leader1Point 'Leader2Point 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SubUnitsFactor 'SubUnitsSuffix 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'SymbolPosition 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimDiametric") (list 'AltRoundDistance 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroInches 'AltSuppressZeroFeet 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'CenterMarkSize 'CenterType 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimTxtDirection 'Fit 'ForceLineInside 'FractionFormat 'LeaderLength 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimOrdinate") (list 'AltRoundDistance 'AltSubUnitsFactor 'AltSubUnitsSuffix 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'ArrowheadSize 'DecimalSeparator 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLineFixedLen 'ExtLineFixedLenSuppress 'FractionFormat 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SubUnitsFactor 'SubUnitsSuffix 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextMovement 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimRadial") (list 'AltRoundDistance 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'ArrowheadBlock 'ArrowheadSize 'ArrowheadType 'CenterMarkSize 'CenterType 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLinetype 'DimensionLineWeight 'DimLineSuppress 'DimTxtDirection 'Fit 'ForceLineInside 'FractionFormat 'LeaderLength 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimRadialLarge") (list 'AltRoundDistance 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'ArrowheadBlock 'ArrowheadSize 'ArrowheadType 'Center 'CenterMarkSize 'CenterType 'ChordPoint 'DecimalSeparator 'DimensionLineColor 'DimensionLinetype 'DimensionLineWeight 'DimLineSuppress 'DimTxtDirection 'Fit 'ForceLineInside 'FractionFormat 'JogAngle 'JogLocation 'LinearScaleFactor 'Measurement 'OverrideCenter 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbDimRotated") (list 'AltRoundDistance 'AltSubUnitsFactor 'AltSubUnitsSuffix 'AltSuppressLeadingZeros 'AltSuppressTrailingZeros 'AltSuppressZeroFeet 'AltSuppressZeroInches 'AltTextPrefix 'AltTextSuffix 'AltTolerancePrecision 'AltToleranceSuppressLeadingZeros 'AltToleranceSuppressTrailingZeros 'AltToleranceSuppressZeroFeet 'AltToleranceSuppressZeroInches 'AltUnits 'AltUnitsFormat 'AltUnitsPrecision 'AltUnitsScale 'Arrowhead1Block 'Arrowhead1Type 'Arrowhead2Block 'Arrowhead2Type 'ArrowheadSize 'DecimalSeparator 'DimConstrDesc 'DimConstrExpression 'DimConstrForm 'DimConstrName 'DimConstrReference 'DimConstrValue 'DimensionLineColor 'DimensionLineExtend 'DimensionLinetype 'DimensionLineWeight 'DimLine1Suppress 'DimLine2Suppress 'DimLineInside 'DimTxtDirection 'ExtensionLineColor 'ExtensionLineExtend 'ExtensionLineOffset 'ExtensionLineWeight 'ExtLine1Linetype 'ExtLine1Suppress 'ExtLine2Linetype 'ExtLine2Suppress 'ExtLineFixedLen 'ExtLineFixedLenSuppress 'Fit 'ForceLineInside 'FractionFormat 'HorizontalTextPosition 'LinearScaleFactor 'Measurement 'PrimaryUnitsPrecision 'Rotation 'RoundDistance 'ScaleFactor 'StyleName 'SubUnitsFactor 'SubUnitsSuffix 'SuppressLeadingZeros 'SuppressTrailingZeros 'SuppressZeroFeet 'SuppressZeroInches 'TextColor 'TextFill 'TextFillColor 'TextGap 'TextHeight 'TextInside 'TextInsideAlign 'TextMovement 'TextOutsideAlign 'TextOverride 'TextPosition 'TextPrefix 'TextRotation 'TextStyle 'TextSuffix 'ToleranceDisplay 'ToleranceHeightScale 'ToleranceJustification 'ToleranceLowerLimit 'TolerancePrecision 'ToleranceSuppressLeadingZeros 'ToleranceSuppressTrailingZeros 'ToleranceSuppressZeroFeet 'ToleranceSuppressZeroInches 'ToleranceUpperLimit 'UnitsFormat 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbEllipse") (list 'Area 'Center 'EndAngle 'EndParameter 'EndPoint 'MajorAxis 'MajorRadius 'MinorAxis 'MinorRadius 'RadiusRatio 'StartAngle 'StartParameter 'StartPoint ) ) ((equal ListPropAcDb "AcDbHatch") (list 'Area 'AssociativeHatch 'BackgroundColor 'Elevation 'GradientAngle 'GradientCentered 'GradientColor1 'GradientColor2 'GradientName 'HatchObjectType 'HatchStyle 'ISOPenWidth 'NumberOfLoops 'Origin 'PatternAngle 'PatternDouble 'PatternName 'PatternScale 'PatternSpace 'PatternType ) ) ((equal ListPropAcDb "AcDbLeader") (list 'Annotation 'ArrowheadBlock 'ArrowheadSize 'ArrowheadType 'Coordinates 'DimensionLineColor 'DimensionLineWeight 'ScaleFactor 'StyleName 'TextGap 'Type 'VerticalTextPosition ) ) ((equal ListPropAcDb "AcDbLWPolyline") (list 'Area 'Closed 'ConstantWidth 'Coordinates 'Elevation 'Length 'Linetype 'LinetypeGeneration 'LinetypeScale 'Lineweight 'Thickness ) ) ((equal ListPropAcDb "AcDbLine") (list 'Angle 'Delta 'EndPoint 'Length 'StartPoint 'Thickness ) ) ((equal ListPropAcDb "AcDbMInsertBlock") (list 'Columns 'ColumnSpacing 'EffectiveName 'HasAttributes 'InsertionPoint 'InsUnits 'InsUnitsFactor 'IsDynamicBlock 'Name 'Rotation 'Rows 'RowSpacing 'XEffectiveScaleFactor 'XScaleFactor 'YEffectiveScaleFactor 'YScaleFactor 'ZEffectiveScaleFactor 'ZScaleFactor ) ) ((equal ListPropAcDb "AcDbMLeader") (list 'ArrowheadBlock 'ArrowheadSize 'ArrowheadType 'BlockConnectionType 'BlockScale 'ContentBlockName 'ContentBlockType 'ContentType 'DogLegged 'DoglegLength 'LandingGap 'LeaderCount 'LeaderLineColor 'LeaderLineType 'LeaderLineWeight 'LeaderType 'ScaleFactor 'StyleName 'TextAttachmentDirection 'TextBackgroundFill 'TextBottomAttachmentType 'TextDirection 'TextFrameDisplay 'TextHeight 'TextJustify 'TextLeftAttachmentType 'TextLineSpacingDistance 'TextLineSpacingFactor 'TextLineSpacingStyle 'TextRightAttachmentType 'TextRotation 'TextString 'TextStyleName 'TextTopAttachmentType 'TextWidth 'Type ) ) ((equal ListPropAcDb "AcDbMLines") (list 'Justification 'MLineScale 'StyleName ) ) ((equal ListPropAcDb "AcDbMtext") (list 'AttachmentPoint 'BackgroundFill 'DrawingDirection 'Height 'InsertionPoint 'LineSpacingDistance 'LineSpacingFactor 'LineSpacingStyle 'Rotation 'StyleName 'TextString 'Width ) ) ((equal ListPropAcDb "AcDbPoints") (list 'Thickness ) ) ((equal ListPropAcDb "AcDbPolyfaceMesh") (list 'Coordinates 'NumberOfFaces 'NumberOfVertices ) ) ((equal ListPropAcDb "AcDbPolyline") (list 'Area 'Closed 'ConstantWidth 'Coordinates 'Elevation 'Length 'Linetype 'LinetypeGeneration 'LinetypeScale 'Lineweight 'Thickness 'Type ) ) ((equal ListPropAcDb "AcDbPolygonMesh") (list 'Coordinates 'MClose 'MDensity 'MVertexCount 'NClose 'NDensity 'NVertexCount 'Type ) ) ((equal ListPropAcDb "AcDbRasterImage") (list 'Brightness 'ClippingEnabled 'Contrast 'Fade 'Height 'ImageFile 'ImageHeight 'ImageVisibility 'ImageWidth 'Name 'Origin 'Rotation 'ScaleFactor 'ShowRotation 'Transparency 'Width ) ) ((equal ListPropAcDb "AcDbWipeout") (list 'Name 'Brightness 'ClippingEnabled 'Contrast 'Fade 'Height 'ImageHeight 'ImageVisibility 'ImageWidth 'Origin 'Rotation 'ScaleFactor 'ShowRotation 'Transparency 'Width ) ) ((equal ListPropAcDb "AcDbRay") (list 'BasePoint 'DirectionVector 'SecondPoint ) ) ((equal ListPropAcDb "AcDbRegion") (list 'Area 'Centroid 'MomentOfInertia 'Perimeter 'PrincipalDirections 'PrincipalMoments 'ProductOfInertia 'RadiiOfGyration ) ) ((equal ListPropAcDb "AcDbShape") (list 'Height 'InsertionPoint 'Name 'ObliqueAngle 'Rotation 'ScaleFactor 'Thickness ) ) ((equal ListPropAcDb "AcDbSolid") (list 'Coordinates 'Thickness ) ) ((equal ListPropAcDb "AcDbSpline") (list 'Area 'Closed 'Closed2 'ControlPoints 'Degree 'Degree2 'EndTangent 'FitPoints 'FitTolerance 'IsPeriodic 'IsPlanar 'IsRational 'KnotParameterization 'Knots 'NumberOfControlPoints 'NumberOfFitPoints 'SplineFrame 'SplineMethod 'StartTangent 'Weights ) ) ((equal ListPropAcDb "AcDbTable") (list 'AllowManualHeights 'AllowManualPositions 'BreaksEnabled 'BreakSpacing 'Columns 'ColumnWidth 'Direction 'EnableBreak 'FlowDirection 'HasSubSelection 'HeaderSuppressed 'Height 'HorzCellMargin 'InsertionPoint 'MinimumTableHeight 'MinimumTableWidth 'RegenerateTableSuppressed 'RepeatBottomLabels 'RepeatTopLabels 'RowHeight 'Rows 'StyleName 'TableBreakFlowDirection 'TableBreakHeight 'TableStyleOverrides 'TitleSuppressed 'VertCellMargin 'Width ) ) ((equal ListPropAcDb "AcDbText") (list 'Alignment 'Backward 'Height 'InsertionPoint 'ObliqueAngle 'Rotation 'ScaleFactor 'StyleName 'TextAlignmentPoint 'TextGenerationFlag 'TextString 'Thickness 'UpsideDown ) ) ((equal ListPropAcDb "AcDbTolerance") (list 'DimensionLineColor 'DirectionVector 'InsertionPoint 'ScaleFactor 'StyleName 'TextColor 'TextHeight 'TextString 'TextStyle ) ) ((equal ListPropAcDb "AcDbTrace") (list 'Coordinates 'Thickness ) ) ((equal ListPropAcDb "AcDbXline") (list 'BasePoint 'DirectionVector 'SecondPoint ) ) ((equal ListPropAcDb "AcDbDynamicBlockReferenceProperty") (list 'AllowedValues 'Description 'PropertyName 'ReadOnly 'Show 'UnitsType 'Value ) ) ) ) ) La fonction retourne une liste des propriétés en fonction du type d'oject (vla-get-objectname). Ca correspond plus à mon besoin, mais moins à un bessoin général tel qu'il est exprimé ci dessus. Encore merci pour la réponse. C'est en forgeant que l'on devient forgerons.Et c'est en sciant que Léonard DeVinci! Lien vers le commentaire Partager sur d’autres sites More sharing options...
GEGEMATIC Posté(e) le 19 février 2013 Partager Posté(e) le 19 février 2013 salut,comme j'ai souvent pensé a faire ce truc, sans passer par d’assommantes listes qui ne seront jamais exhaustive (il y aura toujours de nouvelle entités) voici un petit programme qui retourne la liste des propriétés sans les connaitre d'avance : C'est du brut, il reste forcément un peu de boulot (defun ret_property (/ llign ) ;;(setq llign nil) (setq fname (getvar "LOGFILENAME")) (setvar "LOGFILEMODE" 0) (vl-file-delete fname) (setvar "LOGFILEMODE" 1) (vlax-dump-object (vlax-ename->vla-object (car (entsel)))) (setq fname (getvar "LOGFILENAME")) (setq f (open fname "r")) ;;(vl-file-delete filename) (while (setq lign (read-line f)) (setq llign (cons lign llign)) ) (close f) (setq llign (reverse llign)) (setq llign (cdr (member "; Valeurs de propriétés:" llign))) (setq llign (mapcar '(lambda (x /) (setq pos (vl-string-search "=" x)) (setq x (substr x 2 (- pos 1))) (setq x (vl-string-trim " " x)) (if (setq pos (vl-string-search " " x)) (substr x 1 pos) x ) ) llign ) ) ) ----------------------------------------------------------------------Site: https://www.g-eaux.frBlog: http://g-eaux.over-blog.com Lien vers le commentaire Partager sur d’autres sites More sharing options...
alala Posté(e) le 19 février 2013 Auteur Partager Posté(e) le 19 février 2013 :blink: Passer par le fichier de LOG pour récupérer le dump ... je n'y aurais jamais pensé! EPATANT! Merci beaucoup pour cette routine, je la teste dès que possible mais je ne vois pas de raison pour que (dans le principe) ça ne fonctionne pas! C'est en forgeant que l'on devient forgerons.Et c'est en sciant que Léonard DeVinci! Lien vers le commentaire Partager sur d’autres sites More sharing options...
GEGEMATIC Posté(e) le 19 février 2013 Partager Posté(e) le 19 février 2013 Merci beaucoup pour cette routine, je la teste dès que possible mais je ne vois pas de raison pour que (dans le principe) ça ne fonctionne pas!Salut,merci de ton enthousiasme, bien sur que ça marche, mais il reste des truc à peaufiner, comme tester si logfilon est bien à 1, car sinon effacer le fichier log ne marchera pas, et tester la phrase d'introduction, qui n'est peut être pas la même dans toutes les version d'autocad, et certainement pas dans le versions anglaises ...donc un truc simple finit toujours en usine à gaz ... ----------------------------------------------------------------------Site: https://www.g-eaux.frBlog: http://g-eaux.over-blog.com Lien vers le commentaire Partager sur d’autres sites More sharing options...
alala Posté(e) le 19 février 2013 Auteur Partager Posté(e) le 19 février 2013 BOnjour, Dans tous les cas ce sera toujours moins "usine à gaz" que d'avoir à maintenir une liste de plus de milles lignes de noms de propriétés. Encore merci! C'est en forgeant que l'on devient forgerons.Et c'est en sciant que Léonard DeVinci! Lien vers le commentaire Partager sur d’autres sites More sharing options...
GEGEMATIC Posté(e) le 19 février 2013 Partager Posté(e) le 19 février 2013 Dans tous les cas ce sera toujours moins "usine à gaz" que d'avoir à maintenir une liste de plus de milles lignes de noms de propriétés.Peut être pas ...en testant la routine sur une xref, liste de propriétés plus longue que la ligne sur laquelle j'avais testé, je me suis aperçu que les dernières propriétés manquaient :un vieux problème, depuis l'arrivée du vlisp, Autolisp n'est pas forcément bien séquentiel, il passe à la suite sans s'assurer que la commande précédente est bien terminée (surtout s'il s'agit d'entrée/sortie) Pas moyen de passer par un sémaphore (un prompt "\nFin de dump")dont j'aurai pu tester l’existence, le prompt s'intercale dans le vlax-dump-objectdéfinir la commande en defun-q n'a pas non plus marché, donc j'ai du me rabattre sur un affreux "_delay", qui risque d'être rébarbatif si tu utilise du lisp à l'intérieur d'un commande, ou d'une case de dialogue ... donc voilà l'usine à gaz : ;;************************************************************************** ;;§/vlax/retourne la liste des propriétés (vlax-dump-object) d'une entité / ent (defun pw_lPropertyName (ent / llign lign pos fname f wait) (setq fname (getvar "LOGFILENAME")) (pw_setvar1 "LOGFILEMODE" 0) (pw_setvar1 "CMDECHO" 0) (vl-file-delete fname) (setvar "LOGFILEMODE" 1) (while (not (vlax-dump-object (pw_to_object ent)));_ça non plus ça ne marche pas ... wait ) (command "_delay" 50) (setvar "LOGFILEMODE" 0) (setq fname (getvar "LOGFILENAME")) (setq f (open fname "r")) (while (setq lign (read-line f)) (setq llign (cons lign llign)) ) (close f) (pw_setvar2 "LOGFILEMODE") (pw_setvar2 "CMDECHO") (setq llign (reverse llign)) (setq llign (cdr (member "; Valeurs de propriétés:" llign))) (setq llign (mapcar '(lambda (x /) (setq pos (vl-string-search "=" x)) (setq x (substr x 2 (- pos 1))) (setq x (vl-string-trim " " x)) (if (setq pos (vl-string-search " " x)) (substr x 1 pos) x ) ) llign ) ) ) ----------------------------------------------------------------------Site: https://www.g-eaux.frBlog: http://g-eaux.over-blog.com Lien vers le commentaire Partager sur d’autres sites More sharing options...
VDH-Bruno Posté(e) le 28 juin 2013 Partager Posté(e) le 28 juin 2013 Bonjour, Je trouve cela bien dommage qu'il n'y ait pas de solution pour retrouver ces propriétés par objet sans les lister au préalable. Je viens de poster 2 petites routines ici: http://cadxp.com/topic/37832-lister-les-proprietes-et-les-methodes-applicables-a-un-objet/page__pid__208465#entry208465Monté sur le retour de la fonction atoms-family, fonction que j’avais complétement zappé au moment de cette discussion, je pense que tu devrais pouvoir y trouver une source d’inspiration à ton problème, si c’est encore d’actualité.. A+ Apprendre => Prendre => Rendre Lien vers le commentaire Partager sur d’autres sites More sharing options...
Messages recommandés
Créer un compte ou se connecter pour commenter
Vous devez être membre afin de pouvoir déposer un commentaire
Créer un compte
Créez un compte sur notre communauté. C’est facile !
Créer un nouveau compteSe connecter
Vous avez déjà un compte ? Connectez-vous ici.
Connectez-vous maintenant